<template>
  <q-page padding>
    <q-breadcrumbs>
      <q-breadcrumbs-el label="Home" :to="{ name: 'GeneralIndex' }" />
      <q-breadcrumbs-el :label="breadCrumb" />
    </q-breadcrumbs>

    <h1>{{ modelName }} Facts</h1>

    <div>
      <q-infinite-scroll @load="onLoad" :offset="250" :debounce="300" ref="infiniteScroll" class="row q-gutter-sm">
        <div v-for="item in componentStore.facts" :key="item.id" class="col-12 col-sm-4 col-lg-2">
          <q-card flat bordered class="my-card">
            <q-card-section class="q-gutter-sm">
              <q-btn round icon="edit" color="positive" class="q-mb-md" @click="openDataDialog(item)" />
              <q-btn round icon="delete" color="negative" class="q-mb-md" @click="openDeleteDialog(item.id || 0)" />
            </q-card-section>
            <q-card-section class="q-pt-none">
              {{ item.fact }}
            </q-card-section>
          </q-card>
        </div>
        <template v-slot:loading>
          <div class="row justify-center q-my-md">
            <q-spinner-dots color="primary" size="40px" />
          </div>
        </template>
      </q-infinite-scroll>
    </div>

    <q-dialog v-model="confirm" persistent>
      <q-card>
        <q-card-section class="row items-center">
          <q-avatar icon="report" color="negative" text-color="white" />
          <span class="q-ml-sm">Are you sure you want to delete this fact? THIS ACTION CANNOT BE UNDONE!</span>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Cancel" color="primary" v-close-popup />
          <q-btn flat label="Delete" color="negative" @click="deleteFact" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>

    <q-dialog v-model="prompt" persistent>
      <q-card style="min-width: 350px">
        <q-card-section>
          <div class="text-h6">{{ operation }} {{ modelName }} Fact</div>
        </q-card-section>

        <q-form @submit.prevent="onSubmit">
          <q-card-section class="q-pt-none">
            <q-input dense v-model="fact" autofocus label="Fact"
              :rules="[(value: any) => !!value || 'A fact is Required']" />
          </q-card-section>

          <q-card-actions align="right" class="text-primary">
            <q-btn flat label="Cancel" v-close-popup />
            <q-btn flat label="Save Fact" color="positive" type="submit" />
          </q-card-actions>
        </q-form>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script lang="ts" setup>
import { Ref, ref, toRefs } from 'vue'
const props = defineProps({
  breadCrumb: { type: String, required: true },
  modelName: { type: String, required: true },
  store: { required: true }
})

const infiniteScroll = ref()
const confirm = ref(false)
const prompt = ref(false)
const fact = ref('')
const operation = ref('')
let idToManage = 0

interface Fact {
  id?: number
  fact?: string
}

const { store: componentStore }: { store: Ref } = toRefs(props)

function openDeleteDialog (id: number) {
  confirm.value = true
  idToManage = id
}

function openDataDialog (item?: Fact) {
  operation.value = 'Create'
  fact.value = ''
  if (item) {
    operation.value = 'Edit'
    idToManage = item.id ?? 0
    fact.value = item.fact ?? ''
  }
  prompt.value = true
}

function deleteFact () {
  componentStore.value.deleteFact(idToManage)
    .then(() => {
      idToManage = 0
      infiniteScroll.value.resume()
      infiniteScroll.value.trigger()
    })
}

async function onSubmit () {
  if (idToManage) {
    await componentStore.value.updateFact(idToManage, { fact })
    idToManage = 0
  } else {
    await componentStore.value.storeFact({ fact })
    infiniteScroll.value.reset()
  }
  infiniteScroll.value.resume()
  infiniteScroll.value.trigger()
  prompt.value = false
}

async function onLoad (index: number, done: () => void) {
  const rowsPerPage = 18
  const pageSize = index * rowsPerPage

  const resp = await componentStore.value.getAllFacts({ pageSize, page: 1, order: 'DESC' })

  if (pageSize >= resp.data.total) infiniteScroll.value.stop()

  done()
}

defineExpose({
  openDataDialog
})
</script>

<style lang="scss" scoped>
@media (min-width: 600px) {
  .row>.col-sm-4 {
    height: auto;
    width: 32%;
  }
}

@media (min-width: 1440px) {
  .row>.col-lg-2 {
    height: auto;
    width: 15.94%;
  }
}

.my-card {
  width: 98%;
}
</style>
